gccsite/gcc/urls.py
# Copyright (C) <2018> Association Prologin <association@prologin.org>
# SPDX-License-Identifier: GPL-3.0+

from django.contrib import admin
from django.contrib.auth.decorators import login_required
from django.http import HttpResponse
from django.urls import include, path

from gcc import staff_views, views

app_name = 'gcc'


def crash_test(request):
    if request.user.is_authenticated:
        1 / 0
    return HttpResponse(status=204)


NEWSLETTER_PATTERNS = [
    path(
        'unsubscribe/<str:email>/<str:token>/',
        views.NewsletterUnsubscribeView.as_view(),
        name='news_unsubscribe',
    )
]

APPLICATION_PATTERNS = [
    path(
        'review/',
        staff_views.ApplicationReviewIndexView.as_view(),
        name='application_review_index',
    ),
    path(
        'review/<int:edition>/<int:event>/',
        staff_views.ApplicationReviewView.as_view(),
        name='application_review',
    ),
    path(
        'validation/<int:pk>/<int:edition>/',
        views.ApplicationValidationView.as_view(),
        name='application_validation',
    ),
    path(
        'form/<int:edition>/',
        login_required(
            views.ApplicationFormView.as_view(),
            login_url='https://prologin.org/user/login',
        ),
        name='application_form',
    ),
    path(
        'wishes/<int:edition>/',
        views.ApplicationWishesView.as_view(),
        name='application_wishes',
    ),
    path(
        'summary/<int:pk>/',
        views.ApplicationSummaryView.as_view(),
        name='application_summary',
    ),
    path(
        'confirm/<int:wish>/',
        views.ApplicationConfirmVenueView.as_view(),
        name='confirm',
    ),
    path(
        'label_remove/<int:event>/<int:applicant>/<int:label>/',
        staff_views.ApplicationRemoveLabelView.as_view(),
        name='delete_applicant_label',
    ),
    path(
        'label_add/<int:event>/<int:applicant>/<int:label>/',
        staff_views.ApplicationAddLabelView.as_view(),
        name='add_applicant_label',
    ),
    path(
        'update_wish/<int:wish>/<int:status>/',
        staff_views.UpdateWish.as_view(),
        name='update_wish',
    ),
    path(
        'accept_all/<int:event>/',
        staff_views.ApplicationAcceptView.as_view(),
        name='accept_all',
    ),
    path(
        'accept_all_send/<int:event>/',
        staff_views.ApplicationAcceptSendView.as_view(),
        name='accept_all_send',
    ),
]

urlpatterns = [
    path('', views.IndexView.as_view(), name='index'),
    path('crashtest/', crash_test),
    path('application/', include(APPLICATION_PATTERNS)),
    path('newsletter/', include(NEWSLETTER_PATTERNS)),
    path('learn/', views.LearnMoreView.as_view(), name='learn_more'),
    path('resources/', views.RessourcesView.as_view(), name='resources'),
    path('contact/', views.ContactView.as_view(), name='contact'),
    path('privacy/', views.PrivacyView.as_view(), name='privacy'),
    path('editions/', views.EditionsView.as_view(), name='editions'),
    path(
        'editions/<int:year>/', views.EditionsView.as_view(), name='editions'
    ),
    path('tutorials/', views.TutorialsView.as_view(), name='tutorials'),
    # Remove after february 2020: candidates received a wrong url
    path(
        'confirm/<int:wish>/',
        views.ApplicationConfirmVenueView.as_view(),
        name='confirm',
    ),
    # Admin panel
    path('admin/', admin.site.urls),
]

gccsite/users/urls.py
# Copyright (C) <2019> Association Prologin <association@prologin.org>
# SPDX-License-Identifier: GPL-3.0+

from django.urls import path, include
from users import views

app_name = 'users'

user_patterns = [
    path('profile', views.ProfileView.as_view(), name='profile'),
    path('edit', views.EditUserView.as_view(), name='edit'),
]

urlpatterns = [
    # User profile, view and edit
    path('<int:pk>/', include(user_patterns)),
    # Logout (login is fuly handled by oauth)
    path('logout', views.LogoutView.as_view(), name='logout'),
    # Mailing unsubscribe
    path('unsubscribe', views.UnsubscribeView.as_view(), name='unsubscribe'),
]

gccsite/users/models.py
# Copyright (C) <2019> Association Prologin <association@prologin.org>
# SPDX-License-Identifier: GPL-3.0+

import hashlib

from django.conf import settings
from django.contrib.auth.models import AbstractUser
from django.db import models
from django.urls import reverse
from django.utils.functional import cached_property
from django.utils.translation import ugettext_lazy as _

from gcc.models import Applicant, ApplicantStatusTypes
from prologin.models import (
    AddressableModel,
    ChoiceEnum,
    EnumField,
    GenderField,
)
from timezone_field import TimeZoneField


class EducationStage(ChoiceEnum):
    middle_school = (0, _("Middle school"))
    high_school = (1, _("High school"))
    bac = (2, _("Bac"))
    bacp1 = (3, _("Bac+1"))
    bacp2 = (4, _("Bac+2"))
    bacp3 = (5, _("Bac+3"))
    bacp4 = (6, _("Bac+4"))
    bacp5 = (7, _("Bac+5"))
    bacp6 = (8, _("Bac+6 and after"))
    other = (9, _("Other"))
    former = (10, _("Former student"))

    @classmethod
    def _get_choices(cls):
        return tuple(m.value for m in cls)


class GCCUser(AbstractUser, AddressableModel):
    @staticmethod
    def upload_seed(instance):
        return 'prologinuser/{}'.format(instance.pk).encode()

    # user have to be imported by the oauth client
    id = models.IntegerField(primary_key=True)

    USERNAME_FIELD = 'username'
    REQUIRED_FIELDS = ['email']

    gender = GenderField(blank=True, null=True, db_index=True)

    school_stage = EnumField(
        EducationStage,
        null=True,
        db_index=True,
        blank=True,
        verbose_name=_("Educational stage"),
    )

    phone = models.CharField(
        max_length=16, blank=True, verbose_name=_("Phone")
    )

    birthday = models.DateField(
        blank=True, null=True, verbose_name=_("Birth day")
    )

    allow_mailing = models.BooleanField(
        default=True,
        blank=True,
        db_index=True,
        verbose_name=_("Allow Girls Can Code! to send me emails"),
        help_text=_(
            "We only mail you to provide useful information during the "
            "various stages of the contest. We hate spam as much as "
            "you do!"
        ),
    )

    signature = models.TextField(blank=True, verbose_name=_("Signature"))

    timezone = TimeZoneField(
        default=settings.TIME_ZONE, verbose_name=_("Time zone")
    )

    preferred_locale = models.CharField(
        max_length=8,
        blank=True,
        verbose_name=_("Locale"),
        choices=settings.LANGUAGES,
    )

    @cached_property
    def participations_count(self):
        applicants = Applicant.objects.filter(user=self)
        return sum(
            (applicant.status == ApplicantStatusTypes.confirmed.value)
            for applicant in applicants
        )

    @property
    def unsubscribe_token(self):
        user_id = str(self.id).encode()
        secret = settings.SECRET_KEY.encode()
        return hashlib.sha256(user_id + secret).hexdigest()

    def has_partial_address(self):
        return any((self.address, self.city, self.country, self.postal_code))

    def has_complete_address(self):
        return all((self.address, self.city, self.country, self.postal_code))

    def has_complete_profile(self):
        return self.has_complete_address() and all(
            (
                self.first_name,
                self.last_name,
                self.email,
                self.gender,
                self.birthday,
                self.phone,
            )
        )

    def get_absolute_url(self):
        return reverse('users:profile', args=[self.pk])

    def get_unsubscribe_url(self):
        return '{}{}?uid={}&token={}'.format(
            settings.SITE_BASE_URL,
            reverse('users:unsubscribe'),
            self.id,
            self.unsubscribe_token,
        )

gccsite/gcc/views.py
# Copyright (C) <2019> Association Prologin <association@prologin.org>
# SPDX-License-Identifier: GPL-3.0+

import random
from datetime import datetime

from django.conf import settings
from django.contrib import auth, messages
from django.http import Http404, HttpResponseRedirect
from django.shortcuts import get_object_or_404
from django.urls import reverse, reverse_lazy
from django.utils import timezone
from django.utils.text import format_lazy
from django.utils.translation import ugettext_lazy as _
from django.views.generic import RedirectView, TemplateView
from django.views.generic.detail import DetailView
from django.views.generic.edit import FormView
from django.template.loader import get_template
from django.core.mail import send_mail

from gcc.forms import (
    ApplicationWishesForm,
    CombinedApplicantUserForm,
    EmailForm,
)
from gcc.models import (
    Applicant,
    ApplicantStatusTypes,
    Edition,
    Event,
    EventWish,
    Sponsor,
    SubscriberEmail,
)
from prologin.email import send_email
from rules.contrib.views import PermissionRequiredMixin
from zinnia.models import Entry

# Editions


class EditionsView(TemplateView):
    template_name = "gcc/editions.html"


class TutorialsView(TemplateView):
    template_name = "gcc/tutorials.html"


# Privacy


class PrivacyView(TemplateView):
    template_name = "gcc/privacy.html"


# Homepage


class IndexView(FormView):
    template_name = "gcc/index.html"
    form_class = EmailForm
    success_url = reverse_lazy("gcc:index")

    def form_valid(self, form):
        instance, created = SubscriberEmail.objects.get_or_create(
            email=form.cleaned_data['email']
        )

        if created:
            messages.add_message(
                self.request, messages.SUCCESS, _('Subscription succeeded')
            )
            send_email(
                'gcc/mails/subscribe',
                instance.email,
                {'unsubscribe_url': instance.get_unsubscribe_url},
            )
        else:
            messages.add_message(
                self.request,
                messages.WARNING,
                _('Subscription failed: already subscribed'),
            )

        return super().form_valid(form)

    def get_context_data(self, **kwargs):
        context = super().get_context_data(**kwargs)
        articles = Entry.published.prefetch_related('authors').all()[
            : settings.HOMEPAGE_ARTICLES
        ]
        context.update(
            {
                'last_edition': Edition.objects.latest(),
                'sponsors': list(Sponsor.objects.active()),
                'articles': articles,
            }
        )
        context['events'] = Event.objects.filter(
            signup_start__lt=timezone.now(),
            signup_end__gt=timezone.now(),
            edition=context['last_edition'],
        ).order_by('event_start')
        random.shuffle(context['sponsors'])
        return context


# Ressources, Contact, Learn More


class RessourcesView(TemplateView):
    template_name = "gcc/resources.html"


class ContactView(TemplateView):
    template_name = "gcc/contact.html"


class LearnMoreView(FormView):
    template_name = "gcc/learn_more.html"
    form_class = EmailForm
    success_url = reverse_lazy("gcc:learn_more")

    def form_valid(self, form):
        instance, created = SubscriberEmail.objects.get_or_create(
            email=form.cleaned_data['email']
        )

        if created:
            messages.add_message(
                self.request, messages.SUCCESS, _('Subscription succeeded')
            )
            send_email(
                'gcc/mails/subscribe',
                instance.email,
                {'unsubscribe_url': instance.get_unsubscribe_url},
            )
        else:
            messages.add_message(
                self.request,
                messages.WARNING,
                _('Subscription failed: already subscribed'),
            )

        return super().form_valid(form)

    def get_context_data(self, **kwargs):
        context = super().get_context_data(**kwargs)
        context.update(
            {
                'last_edition': Edition.objects.latest(),
                'SITE_HOST': settings.SITE_HOST,
            }
        )
        context['events'] = Event.objects.filter(
            signup_start__lt=timezone.now(),
            signup_end__gt=timezone.now(),
            edition=context['last_edition'],
        ).order_by('event_start')
        return context


# Newsletter


class NewsletterUnsubscribeView(RedirectView):
    def get_redirect_url(self, *args, **kwargs):
        return reverse('gcc:index')

    def get(self, request, *args, **kwargs):
        try:
            subscriber = SubscriberEmail.objects.get(email=kwargs['email'])

            if subscriber.unsubscribe_token == kwargs['token']:
                subscriber.delete()
                messages.add_message(
                    request,
                    messages.SUCCESS,
                    _('Successfully unsubscribed from newsletter.'),
                )
            else:
                messages.add_message(
                    request,
                    messages.ERROR,
                    _('Failed to unsubscribe: wrong token.'),
                )
        except SubscriberEmail.DoesNotExist:
            messages.add_message(
                request,
                messages.ERROR,
                _('Failed to unsubscribe: unregistered address'),
            )

        return super().get(request, *args, **kwargs)


# Application


class ApplicationSummaryView(PermissionRequiredMixin, DetailView):
    model = auth.get_user_model()
    context_object_name = 'shown_user'
    template_name = 'gcc/application/summary.html'
    permission_required = 'users.edit'
    success_url = reverse_lazy("gcc:summary")

    def get_context_data(self, **kwargs):
        context = super().get_context_data(**kwargs)
        shown_user = context[self.context_object_name]

        context.update(
            {
                'shown_user': shown_user,
                'current_edition': Edition.current(),
                'applicant': get_object_or_404(
                    Applicant, user=shown_user, edition=Edition.current()
                ),
                'has_applied_to_current': Edition.current().user_has_applied(
                    shown_user
                ),
            }
        )
        return context

    def get(self, request, *args, **kwargs):
        result = super().get(request, *args, **kwargs)
        if not self.object.is_active and not self.request.user.is_staff:
            raise Http404()
        return result


class ApplicationValidationView(PermissionRequiredMixin, DetailView):
    model = auth.get_user_model()
    context_object_name = 'shown_user'
    template_name = 'gcc/application/validation.html'
    permission_required = 'users.edit'

    def get(self, request, *args, **kwargs):
        result = super().get(request, *args, **kwargs)
        if not self.object.is_active and not self.request.user.is_staff:
            raise Http404()
        return result

    # TODO: remove redondancy of get
    def get_context_data(self, **kwargs):
        applicant = get_object_or_404(
            Applicant, user=self.request.user, edition=self.kwargs['edition']
        )
        context = super().get_context_data(**kwargs)
        context['applicant'] = applicant
        return context

    def get_success_url(self):
        return reverse(
            'gcc:application_summary', kwargs={'pk': self.request.user.pk}
        )

    def post(self, request, *args, **kwargs):
        super().get(request, *args, **kwargs)

        applicant = get_object_or_404(
            Applicant, user=self.request.user, edition=kwargs['edition']
        )

        if not applicant.has_complete_application():
            messages.add_message(
                request,
                messages.ERROR,
                _(
                    'Failed to validate your application, your '
                    'profile is incomplete.'
                ),
            )
        else:
            applicant.validate_current_wishes()
            messages.add_message(
                request,
                messages.SUCCESS,
                _(
                    'Successfully validated your application. '
                    'You should receive a confirmation email soon.'
                ),
            )
            send_mail(
                format_lazy(
                    "[Girls Can Code!][{}] {}",
                    Edition.current().year,
                    _("Application confirmation"),
                ),
                get_template('gcc/mails/application.body.text.html').render(
                    {'applicant': applicant}
                ),
                settings.DEFAULT_FROM_EMAIL,
                [self.request.user.email]
                # TODO Change this when settings.GCC_EDITION is up
            )

        if not self.object.is_active and not self.request.user.is_staff:
            raise Http404()

        return HttpResponseRedirect(
            reverse(
                'gcc:application_summary', kwargs={'pk': self.request.user.pk}
            )
        )


class ApplicationFormView(FormView):
    template_name = 'gcc/application/form.html'
    form_class = CombinedApplicantUserForm

    def dispatch(self, request, *args, **kwargs):
        # Redirect if already validated for this year.
        if request.user.is_anonymous:
            return super().dispatch(request, *args, **kwargs)

        edition = get_object_or_404(Edition, year=kwargs['edition'])
        applicant = Applicant.for_user_and_edition(self.request.user, edition)

        if applicant.is_locked():
            messages.add_message(
                request,
                messages.ERROR,
                _(
                    'Your application has already been validated, if you '

gccsite/gcc/templates/gcc/learn_more.html
{% extends "gcc/base.html" %}

{% load static %}
{% load i18n %}

{% block title %}{% trans 'Main Informations' %}{% endblock %}

{% block content %}
<div class="col-sm-3">
  {% include 'gcc/registration_widget.html' %}
</div>

<div class="container col-md-9">
  <h2>{% trans 'The different types of Summer Camps' %}</h2>
    <p>{% blocktrans %}
        There are two types of Girls Can Code! summer camps:
        <ul>
            <li>Long ones, they last for a week. They were first created in 2014.</li>
            <li>Short ones, also called "Girls Can Code! Week-end", they started in 2019.</li>
        </ul>
    {% endblocktrans %}</p>

  <h2>{% trans 'Content and schedule of the week-end Summer Camps' %}</h2>
  <p>{% blocktrans %}
      They are shorter thus give less time to discover the variety of computer science but can be
      organized more often and in various locations. They can focus on special topics but as a
      default they are an introduction to computer science via practical sessions. The first day
      focuses on the discovery of Python and the next on the creation of a small project on a
      microcontroller.
  {% endblocktrans %}</p>

  <p>
  {% blocktrans %}Here is an example schedule of a GCC! week-end, but the time of arrival and
  departure may vary, you will be sent a precise one when accepted.{% endblocktrans %}
    </p>
    <a href="{% static 'gcc/img/schedule_short.svg'%}">
      <img  style="width: 50%;" alt="Typical Schedule of a GCC! Week-end" src="{% static 'gcc/img/schedule_short.svg' %}" />
    </a>

  <h2>{% trans 'Content and schedule of the week-long Summer Camps' %}</h2>
  <p>
    {% blocktrans %}The summer camps lasts for one week and mainly consist of practical exercises.
    The week starts with an initiation to the Python programming language, and then some
    introductive tutorials about several subdomains of informatics like network or web design.
    Finally, the week ends with a personal project, that can be chosen among several main topics:
    video game, robotics or microcontroller.{% endblocktrans %}
  </p>
  <p>
    {% blocktrans %}Here is a typical schedule of a GCC! week. Notice that the attendees can arrive
    between 9 am and 9:30 am and can leave at between 5 pm and 6 pm.{% endblocktrans %}
  </p>
  <a href="{% static 'gcc/img/schedule.svg'%}">
    <img alt="Typical Schedule of a GCC! Week" src="{% static 'gcc/img/schedule.svg' %}" />
  </a>

  <h2>{% trans 'Academic Level' %}</h2>
  <p>
    {% blocktrans %}We accept girls attending to secondary school are higher, the difficulty of the
    internship aims at adapting to the knowledge of all participants.{% endblocktrans %}
  </p>

  <p>
    {% url 'gcc:privacy' as privacy_url %}
    {% blocktrans %}Please take some time reading our article about privacy:
    <a href="{{privacy_url}}">{{SITE_HOST}}{{privacy_url}}</a>{% endblocktrans %}
  </p>
</div>
{% endblock %}

gccsite/gcc/templates/gcc/main-footer.html
{% load i18n %}
{% load utils %}
{% load navigation rules %}

<div class="row">
  <div class="col-md-4">
    <h3>{% trans "Girls Can Code!" %}</h3>
    <ul class="nav">
        <li><a href="{% url 'gcc:index' %}">{% trans 'Home' %}</a></li>
        <li class="{% active '^/gcc/learn/' %}"><a href="{% url 'gcc:learn_more' %}">{% trans 'The summer camps' %}</a></li>
        <li class="{% active '^/gcc/resources/' %}"><a href="{% url 'gcc:resources' %}">{% trans 'Ressources' %}</a></li>
        <li class="{% active '^/gcc/editions/' %}"><a href="{% url 'gcc:editions' %}">{% trans 'Past editions' %}</a></li>
        <li class="{% active '^/gcc/contact/' %}"><a href="{% url 'gcc:contact' %}"> {% trans 'Contact' %}</a></li>
        <li class="{% active '^/gcc/privacy/' %}"><a href="{% url 'gcc:privacy' %}">{% trans 'Privacy' %}</a></li>
    </ul>

  </div>
  <div class="col-md-4">
    {# social shit #}
    <a href="https://www.facebook.com/stagegirlscancode" title="{% trans "Girls Can Code! on Facebook" %}" class="social">
      <span class="fa-stack fa-lg">
        <i class="fa fa-square-o fa-stack-2x fa-inverse"></i>
        <i class="fa fa-facebook fa-stack-1x fa-inverse"></i>
      </span>
    </a>
    <a href="https://www.twitter.com/prologin" title="{% trans "Prologin on Twitter" %}" class="social">
      <span class="fa-stack fa-lg">
        <i class="fa fa-square-o fa-stack-2x fa-inverse"></i>
        <i class="fa fa-twitter fa-stack-1x fa-inverse"></i>
      </span>
    </a>
  </div>
  <div class="col-md-4">
    <h3>{% trans "Change locale" %} <i class=" fa fa-globe"></i></h3>
    {% get_current_language as LANGUAGE_CODE %}
    <form action="{% url 'set_language' %}" method="post" id="change-lang-form" class="form-inline">
      {% csrf_token %}
      {# <input name="next" type="hidden" value="{{ redirect_to }}"/> #}
      <select name="language" id="set-language" class="form-control" onchange="$('#change-lang-form').submit();">
        {% get_available_languages as LANGUAGES %}
        {% get_language_info_list for LANGUAGES as languages %}
        {% for language in languages %}
          <option value="{{ language.code }}"{% if language.code == LANGUAGE_CODE %}
              selected="selected"{% endif %}>{{ language.name_local.title }}</option>
        {% endfor %}
      </select>
      <noscript><input type="submit" class="btn btn-default" value="{% trans "Apply" %}"/></noscript>
      {% if request.user.is_authenticated and LANGUAGE_CODE != request.user.preferred_locale %}
        {% url 'users:edit' request.user.pk as user_edit_url %}
        <p><small class="text-muted">{% blocktrans with url=user_edit_url %}Save your
preferred locale in your <a href="{{ url }}#id_preferred_locale">user settings</a>.{% endblocktrans %}</small></p>
      {% endif %}
    </form>
  </div>
</div>

gccsite/gcc/templates/gcc/main-menu.html
{% load i18n %}
{% load navigation rules %}

<ul class="nav navbar-nav pull-right">
    <li><a href="{% url 'gcc:learn_more' %}">{% trans 'The summer camps' %}</a></li>
    <li class="{% active '^/gcc/resources/' %}"><a href="{% url 'gcc:resources' %}">{% trans 'Ressources' %}</a></li>
    <li class="{% active '^/gcc/editions/' %}"><a href="{% url 'gcc:editions' %}">{% trans 'Past editions' %}</a></li>
    <li class="dropdown">
        <a href="#" class="dropdown-toggle" data-toggle="dropdown" role="button"
            aria-expanded="false">{% trans ' Tutorials ' %}<span class="caret"></span></a>
        <ul class="dropdown-menu dropdown-menu-right" role="menu">
          <li><a href="{% url 'gcc:tutorials' %}">{% trans 'The Tutorials' %}</a></li>
          <li class="divider"></li>
          <li><a href="{% url 'gcc:tutorials' %}#editor">{% trans 'Coding in Python' %}</a></li>
          <li><a href="{% url 'gcc:tutorials' %}#intro">{% trans 'Python Introduction' %}</a></li>
          <li><a href="{% url 'gcc:tutorials' %}#lists">{% trans 'Lists and strings' %}</a></li>
          <li><a href="{% url 'gcc:tutorials' %}#object">{% trans 'Object' %}</a></li>
          <li><a href="{% url 'gcc:tutorials' %}#web">{% trans 'Web' %}</a></li>
          <li><a href="{% url 'gcc:tutorials' %}#game">{% trans 'Game' %}</a></li>
        </ul>
      </li>
    {% if request.user.is_staff %}
      <li class="dropdown">
        <a href="#" class="dropdown-toggle" data-toggle="dropdown" role="button" aria-expanded="false"><i class="fa fa-star"></i> Admin <span class="caret"></span></a>
        <ul class="dropdown-menu dropdown-menu-right" role="menu">
          <li><a href="{% url 'admin:index' %}">{% trans "Django administration" %}</a></li>
          <li class="divider"></li>
          <li><a href="{% url 'gcc:application_review_index' %}"><i class="fa fa-fw fa-wrench"></i> {% trans "Review Candidates" %}</a></li>
          {% has_perm 'massmailer.admin' request.user as can_do_mailing %}
          {% if can_do_mailing %}<li><a href="{% url 'massmailer:dashboard' %}"><i class="fa fa-fw fa-envelope-o"></i> {% trans "Mailing" %}</a></li>{% endif %}

        </ul>
      </li>
    {% endif%}
    <li class="sep"><a>&nbsp;</a></li>
    {% if not user.is_authenticated %}
      <li><a href="{% url 'proloauth_client:autologin' %}?next={{ request.path }}">{% trans 'Sign in with Prologin' %}</a></li>
    {% else %}
      <li class="dropdown">
        <a href="#" class="dropdown-toggle" data-toggle="dropdown" role="button" aria-expanded="false"><i class="fa fa-user"></i> {{ user.username }} <span class="caret"></span></a>
        <ul class="dropdown-menu dropdown-menu-right" role="menu">
          <li><a href="{% url 'users:profile' user.id %}"><i class="fa fa-user"></i> {% trans 'My profile' %}</a></li>
          <li><a href="{% url 'users:edit' user.id %}"><i class="fa fa-cog"></i> {% trans 'Profile & options' %}</a></li>
          <li><a href="{% url 'gcc:application_summary' user.id %}"><i class="fa fa-pencil-alt"></i>{% trans 'My applications' %}</a></li>
          <li>
              <form method="post" action="{% url 'users:logout' %}">
              {% csrf_token %}
              <button type="submit">{% trans 'Sign out' %}</button>
            </form>
          </li>
        </ul>
      </li>
    {% endif %}
</ul>

gccsite/gcc/templates/gcc/newsletter_widget.html
{% load i18n %}
{% load bootstrap %}

<p>
  {% blocktrans %}
    Subscribe to the newsletter to get updated with the latest news.
  {% endblocktrans %}
</p>
<form action="" method="POST" class="form-horizontal">
  {% csrf_token %}
  {{ form|bootstrap_horizontal:'col-sm-3' }}
  <div class="form-group">
    <div class="col-sm-offset-3 col-sm-9">
      <button class="btn btn-primary" type="submit">
        <i class="fa fa-newspaper-o"></i> {% trans "Subscribe" %}
      </button>
    </div>
  </div>
</form>

gccsite/gcc/templates/gcc/registration_widget.html
{% load i18n %}

{% block content %}
<section class="up-comming">

  {% if last_edition.subscription_is_open %}
    <h2>{% trans "Summer camps open for registration" %}</h2>
    <table class="table">
      <tbody>
        {% for event in events %}
        <tr>
          <td>
            <strong>{{ event.center }}</strong>,
            <em> {% blocktrans with event.event_start|date:"DATE_FORMAT" as start and event.event_end|date:"DATE_FORMAT" as end %}
              from the {{ start }} to the {{ end }}
              {% endblocktrans %}
            </em>
          </td>
        </tr>
        {% endfor %}
      </tbody>
    </table>
  <p>
    {% if user.is_authenticated %}
      <a href="/application/form/{{last_edition}}" class="btn btn-primary btn-lg btn-block">{% trans 'Apply' %}</a>
    {% else %}
      <a href="{% url 'proloauth_client:autologin' %}?next={% url 'gcc:application_form' last_edition.year %}" class="btn btn-primary btn-lg btn-block">{% trans 'Sign in and apply' %}</a>
    {% endif %}
  </p>
  {% else %}
    <h3>{% trans "No summer camps currently open for registration" %}</h3>
  {% endif %}
  {% include 'gcc/newsletter_widget.html' %}
</section>
{% endblock %}